//+------------------------------------------------------------------+
//|                                                BB Stochastic.mq4 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_separate_window

#property  indicator_buffers 3
#property  indicator_color1  clrLightSeaGreen
#property  indicator_color2  clrRed
#property  indicator_color3  clrOrange
#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_width3  1

#property indicator_level1     20.0
#property indicator_level2     80.0
#property indicator_level3     45.0
#property indicator_level4     55.0
#property indicator_levelcolor clrSilver
#property indicator_levelstyle STYLE_DOT
//---- indicator parameters
extern int Prcnt_K = 5;
extern int Prcnt_D = 3;
extern int Slowing = 2;

extern int Lt_Prcnt_K = 14;
extern int Lt_Prcnt_D = 7;
extern int Lt_Slowing = 3;
//---- indicator buffers
double K_Line[];
double D_Line[];
double Lt_K_Line[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping

   IndicatorDigits(Digits);

//---- buffer 0
   SetIndexBuffer(0,K_Line);
   SetIndexStyle(0,DRAW_LINE);
//---- buffer 1
   SetIndexBuffer(1,D_Line);
   SetIndexStyle(1,DRAW_LINE);
//---- buffer 2
   SetIndexBuffer(2,Lt_K_Line);
   SetIndexStyle(2,DRAW_LINE);
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("BB Stochastic (" + (string)Prcnt_K + "," + (string)Prcnt_D + "," + (string)Slowing + ":" + (string)Lt_Prcnt_K + "," + (string)Lt_Prcnt_D + "," + (string)Lt_Slowing + ")");
   SetIndexLabel(0,"Growing MACD");
   SetIndexLabel(1,"Shrinking MACD");
   SetIndexLabel(0,"Growing MACD Signal");
   SetIndexLabel(1,"Shrinking MACD Signal");   
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
int limit, i;
   
    if(!prev_calculated) limit = rates_total;
    else limit = rates_total-prev_calculated ;
   
      for( i = 0; i < limit; i++)
        {
         K_Line[i] =iStochastic(NULL,0,Prcnt_K,Prcnt_D,Slowing,MODE_SMA,0,MODE_MAIN,i);
         D_Line[i] =iStochastic(NULL,0,Prcnt_K,Prcnt_D,Slowing,MODE_SMA,0,MODE_SIGNAL,i);
         Lt_K_Line[i] =iStochastic(NULL,0,Lt_Prcnt_K,Lt_Prcnt_D,Lt_Slowing,MODE_SMA,0,MODE_MAIN,i);
        }
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
